// Jean Luc Biellmann - contact@alsatux.com

"use strict";

var _EventGUI = {
	init: function () {
		// all day button
		document.getElementById('button_event_allday').addEventListener("click", _EventGUI.allday);
		// event buttons
		document.getElementById('button_event_submit').addEventListener("click",_EventGUI.add);
		document.getElementById('button_event_delete').addEventListener("click",_EventGUI.del);
		document.getElementById('button_event_close').addEventListener("click",_EventGUI.hide);
	},
	show: function (event) {
		document.getElementById('div_edit_event').style.display = '';
		document.getElementById('event_seq').value = event.seq;
		document.getElementById('event_start_date').value = event.start_date;
		document.getElementById('event_start_hour').innerHTML = _Fmt.two_digits(event.start_hour);
		document.getElementById('event_start_minute').innerHTML = _Fmt.two_digits(event.start_minute);
		document.getElementById('event_duration_hour').innerHTML = _Fmt.two_digits(event.duration_hour);
		document.getElementById('event_duration_minute').innerHTML = _Fmt.two_digits(event.duration_minute);
		document.getElementById('event_title').value = event.title;
		document.getElementById('event_description').value = event.description;
		// rrule
		document.getElementById('event_rrule_freq').innerHTML = event.rrule.freq;
		document.getElementById('event_rrule_count').value = event.rrule.count;
		document.getElementById('event_rrule_interval').value = event.rrule.interval;
		document.getElementById('event_rrule_until').value = event.rrule.until;
		_RepeatGUI.select_freq(event.rrule.freq);
		_EventGUI.upd_buttons();
	},
	hide: function (e) {
		document.getElementById('div_edit_event').style.display = 'none';
	},
	add: function (e) {
		var seq = document.getElementById('event_seq').value;
		var event = {
			'seq': seq,
			'start_date': document.getElementById('event_start_date').value,
			'start_hour': document.getElementById('event_start_hour').innerHTML,
			'start_minute': document.getElementById('event_start_minute').innerHTML,
			'duration_hour': document.getElementById('event_duration_hour').innerHTML,
			'duration_minute': document.getElementById('event_duration_minute').innerHTML,
			'title': document.getElementById('event_title').value,
			'description': document.getElementById('event_description').value,
			'rrule': {
				'freq': document.getElementById('event_rrule_freq').value,
				'until': document.getElementById('event_rrule_until').value,
				'count': document.getElementById('event_rrule_count').value,
				'interval': document.getElementById('event_rrule_interval').value,
			}
		};
		_EventGUI.hide();
		if (_EventDB.upd(event)) {
			_CalGUI.del(seq);
			_CalGUI.add(_EventDB.db[seq]);
			//if (_Storage.allowed())
				_EventDB.save();
		}
	},
	del: function (e) {
		var seq = document.getElementById('event_seq').value;
		_EventGUI.hide();
		_CalGUI.del(seq);
		_EventDB.del(seq);
		//if (_Storage.allowed())
			_EventDB.save();
	},
	allday: function () {
		document.getElementById('event_start_hour').innerHTML = _Fmt.two_digits(0);
		document.getElementById('event_start_minute').innerHTML = _Fmt.two_digits(0);
		document.getElementById('event_duration_hour').innerHTML = _Fmt.two_digits(24);
		document.getElementById('event_duration_minute').innerHTML = _Fmt.two_digits(0);
		_EventGUI.upd_buttons();
	},
	upd_buttons: function () {
		// update repeat button according to parameters
		var button = document.getElementById('button_event_repeat');
		var repeated = document.getElementById('event_rrule_until').value.length || document.getElementById('event_rrule_freq_radio').querySelectorAll('li.selected').length;
		if (repeated) {
			if (button.className.indexOf('selected')==-1)
				button.className += ' selected';
		} else {
			if (button.className.indexOf('selected')!=-1)
				button.className = button.className.replace(/ selected/, '');
		}
		// update allday button
		var allday = document.getElementById('event_start_hour').innerHTML=='00' && document.getElementById('event_start_minute').innerHTML=='00' && document.getElementById('event_duration_hour').innerHTML=='24' && document.getElementById('event_duration_minute').innerHTML=='00';
		button = document.getElementById('button_event_allday');
		if (allday) {
			if (button.className.indexOf('selected')==-1)
				button.className += ' selected';
		} else {
			if (button.className.indexOf('selected')!=-1)
				button.className = button.className.replace(/ selected/, '');
		}
	}
};

